﻿// CodeGear C++Builder
// Copyright (c) 1995, 2022 by Embarcadero Technologies, Inc.
// All rights reserved

// (DO NOT EDIT: machine generated header) 'Winsoft.iOS.NfcDna.pas' rev: 35.00 (iOS)

#ifndef Winsoft_Ios_NfcdnaHPP
#define Winsoft_Ios_NfcdnaHPP

#pragma delphiheader begin
#pragma option push
#pragma option -w-      // All warnings off
#pragma option -Vx      // Zero-length empty class member 
#pragma pack(push,8)
#include <System.hpp>
#include <SysInit.hpp>
#include <System.SysUtils.hpp>
#include <iOSapi.Security.hpp>
#include <Winsoft.iOS.Nfc.hpp>
#include <Winsoft.iOS.Ev2.hpp>

//-- user supplied -----------------------------------------------------------

namespace Winsoft
{
namespace Ios
{
namespace Nfcdna
{
//-- forward type declarations -----------------------------------------------
__interface DELPHIINTERFACE TCompletion;
typedef System::DelphiInterface<TCompletion> _di_TCompletion;
__interface DELPHIINTERFACE TCompletionByte;
typedef System::DelphiInterface<TCompletionByte> _di_TCompletionByte;
__interface DELPHIINTERFACE TCompletionBytes;
typedef System::DelphiInterface<TCompletionBytes> _di_TCompletionBytes;
__interface DELPHIINTERFACE TCompletionFileSettings;
typedef System::DelphiInterface<TCompletionFileSettings> _di_TCompletionFileSettings;
class DELPHICLASS TNTag424;
//-- type declarations -------------------------------------------------------
enum class DECLSPEC_DENUM TAccess : unsigned char { MasterKey, AppKey1, AppKey2, AppKey3, AppKey4, Free, No };

enum class DECLSPEC_DENUM TAuthentication : unsigned char { Ev2, Lrp };

enum class DECLSPEC_DENUM TCommunication : unsigned char { Plain, Mac, Full };

enum class DECLSPEC_DENUM TFile : unsigned char { File1, File2, File3 };

enum class DECLSPEC_DENUM TKey : unsigned char { MasterKey, Key1, Key2, Key3, Key4 };

__interface TCompletion  : public System::IInterface 
{
	virtual void __fastcall Invoke(System::Sysutils::Exception* const E) = 0 ;
};

__interface TCompletionByte  : public System::IInterface 
{
	virtual void __fastcall Invoke(System::Byte Data, System::Sysutils::Exception* const E) = 0 ;
};

__interface TCompletionBytes  : public System::IInterface 
{
	virtual void __fastcall Invoke(const System::TArray__1<System::Byte> Data, System::Sysutils::Exception* const E) = 0 ;
};

__interface TCompletionFileSettings  : public System::IInterface 
{
	virtual void __fastcall Invoke(bool Mirroring, TCommunication Communication, TAccess Read, TAccess Write, TAccess ReadWrite, TAccess ChangeSettings, int FileSize, System::Sysutils::Exception* const E) = 0 ;
};

class PASCALIMPLEMENTATION TNTag424 : public System::TObject
{
	typedef System::TObject inherited;
	
private:
	bool FAuthenticatedEv2;
	bool FAuthenticatedLrp;
	System::Word FCommandCounter;
	Winsoft::Ios::Nfc::TISO7816Tag FISO7816Tag;
	unsigned FTransactionId;
	System::TArray__1<System::Byte> __fastcall DecodeResponse(System::TArray__1<System::Byte> Response, TCommunication Communication, bool Allow9190 = false);
	System::TArray__1<System::Byte> __fastcall EncodeRequest(System::TArray__1<System::Byte> Request, int CmdSize, TCommunication Communication);
	bool __fastcall GetAuthenticated();
	TCommunication __fastcall GetCommunication(TCommunication Requested);
	void __fastcall GetVersionPart1(_di_TCompletionBytes Completion);
	void __fastcall GetVersionPart2(_di_TCompletionBytes Completion);
	void __fastcall GetVersionPart3(_di_TCompletionBytes Completion);
	void __fastcall IsoSelectFile(System::Word FileId, _di_TCompletion Completion);
	void __fastcall SendIsoSelectCommand(System::TArray__1<System::Byte> Request, _di_TCompletion Completion);
	void __fastcall SendCommand(System::TArray__1<System::Byte> Request, int CmdSize, TCommunication Communication, _di_TCompletionBytes Completion, bool Allow9190 = false);
	void __fastcall Transceive(const System::TArray__1<System::Byte> Request, _di_TCompletionBytes Completion);
	__property bool AuthenticatedEv2 = {read=FAuthenticatedEv2, nodefault};
	__property bool AuthenticatedLrp = {read=FAuthenticatedLrp, nodefault};
	
public:
	__fastcall TNTag424(const Winsoft::Ios::Nfc::TISO7816Tag &ISO7816Tag);
	__fastcall virtual ~TNTag424();
	void __fastcall Authenticate(TAuthentication Mode, TKey Key, const Winsoft::Ios::Ev2::TBlock &KeyData, _di_TCompletion Completion, bool NonFirst = false);
	void __fastcall ChangeFileSettings(TFile File, TCommunication Communication, TAccess Read, TAccess Write, TAccess ReadWrite, TAccess ChangeSettings, _di_TCompletion Completion);
	void __fastcall ChangeKey(TKey Key, const Winsoft::Ios::Ev2::TBlock &OldKeyData, const Winsoft::Ios::Ev2::TBlock &NewKeyData, System::Byte KeyVersion, _di_TCompletion Completion);
	void __fastcall GetCardUid(_di_TCompletionBytes Completion);
	void __fastcall GetFileSettings(TFile File, _di_TCompletionFileSettings Completion);
	void __fastcall GetKeyVersion(TKey Key, _di_TCompletionByte Completion);
	void __fastcall GetVersion(_di_TCompletionBytes Completion);
	void __fastcall IsoReadBinary(_di_TCompletionBytes Completion);
	void __fastcall IsoSelect(TFile File, _di_TCompletion Completion);
	void __fastcall IsoSelectDedicatedFile(_di_TCompletion Completion);
	void __fastcall IsoSelectMasterFile(_di_TCompletion Completion);
	void __fastcall IsoUpdateBinary(const System::TArray__1<System::Byte> Data, System::Byte Offset, _di_TCompletion Completion);
	void __fastcall ReadData(TFile File, TCommunication Communication, _di_TCompletionBytes Completion, System::Byte Offset = (System::Byte)(0x0), System::Byte Length = (System::Byte)(0x0));
	void __fastcall ReadSignature(_di_TCompletionBytes Completion);
	void __fastcall SetLrp(_di_TCompletion Completion);
	void __fastcall SetRandomUid(_di_TCompletion Completion);
	void __fastcall WriteData(TFile File, TCommunication Communication, const System::TArray__1<System::Byte> Data, _di_TCompletion Completion, System::Byte Offset = (System::Byte)(0x0));
	__property bool Authenticated = {read=GetAuthenticated, nodefault};
	__property Winsoft::Ios::Nfc::TISO7816Tag ISO7816Tag = {read=FISO7816Tag};
	__property unsigned TransactionId = {read=FTransactionId, nodefault};
};


//-- var, const, procedure ---------------------------------------------------
}	/* namespace Nfcdna */
}	/* namespace Ios */
}	/* namespace Winsoft */
#if !defined(DELPHIHEADER_NO_IMPLICIT_NAMESPACE_USE) && !defined(NO_USING_NAMESPACE_WINSOFT_IOS_NFCDNA)
using namespace Winsoft::Ios::Nfcdna;
#endif
#if !defined(DELPHIHEADER_NO_IMPLICIT_NAMESPACE_USE) && !defined(NO_USING_NAMESPACE_WINSOFT_IOS)
using namespace Winsoft::Ios;
#endif
#if !defined(DELPHIHEADER_NO_IMPLICIT_NAMESPACE_USE) && !defined(NO_USING_NAMESPACE_WINSOFT)
using namespace Winsoft;
#endif
#pragma pack(pop)
#pragma option pop

#pragma delphiheader end.
//-- end unit ----------------------------------------------------------------
#endif	// Winsoft_Ios_NfcdnaHPP
